%%  BEM simulation
 
CASE_A
%CASE_B

op1 = bemoptions( 'sim', 'ret', 'interp', 'curv' );

%  set up BEM solvers
bem1 = bemsolver( p, op1 );


%  plane wave excitation
% two excitations RCP, LCP for calculating Jones matrix or other polarizations for calculating the intensity
%each time one polarization state is worked out 

exc1 = planewave( [ 1, 1i, 0; 1, -1i, 0 ], [ 0, 0, 1; 0, 0, 1], op1 );

   

   %  light wavelength in vacuum

           enei = linspace(1000,2000,30);
        

% allocate S matrix (Jones matrix: S1=J22. S2=J11, S3=J12, S4=J21 )
S1 = zeros( length( enei ),1);
S2 = zeros( length( enei ),1);
S3 = zeros( length( enei ),1);
S4 = zeros( length( enei ),1);

% allocate the electric field components for each excitation
E1x = zeros( length( enei ),1);
E1y = zeros( length( enei ),1);
E2x = zeros( length( enei ),1);
E2y = zeros( length( enei ),1);

   inten1 = zeros( length( enei ),1);
   inten2 = zeros( length( enei ),1);

% scattering direction: we look at infinity!!!!
% THIS IS IMPORTANT; the calculation of the S-matrix below is valid only
% if we look at +infinity, some other direction would require different
% relations
scadir = [1,0,0];
figure;
for ien = 1 : length( enei )
  ien
  

  
  
  %  surface charge
  sig1 = bem1 \ exc1( p, enei( ien ) );   
     
  
  % calculate the far field
  spec = spectrum( scadir,op1); 
  f = farfield( spec, sig1 );
  
  factor = -1i*2*pi/enei(ien); 
  Esx1 = squeeze(f.e(:,3,1));
  Esx2 = squeeze(f.e(:,3,2));
  Esy1 = squeeze(f.e(:,2,1));
  Esy2 = squeeze(f.e(:,2,2));
  

  
 % calulate the Jones matrix (Jones matrix: S1=J22. S2=J11, S3=J12, S4=J21 )
  S1(ien) = (-Esy2+Esy1)/(2*1i);
  S2(ien) = ( Esx1+Esx2)/2;
  S3(ien) = ( Esx2-Esx1)/(2*1i);
  S4(ien) = -(Esy2+Esy1)/2;

 % the local values (no vectors)
  S1a = (-Esy2+Esy1)/(2*1i);
  S2a = ( Esx1+Esx2)/2;
  S3a = ( Esx2-Esx1)/(2*1i);
  S4a = -(Esy2+Esy1)/2;

  
  %intensity
  inten1(ien)=S2a*conj(S2a)+S4a*conj(S4a);
  inten2(ien)=S1a*conj(S1a)+S3a*conj(S3a);

 plot( enei, inten1,'g-', enei,inten2,'r-','LineWidth',2);
title('CASE A')
legend('H illumination','V illumination')
  grid on
  drawnow
   end
  % close waitbar
%write the Jones matrix in an excel file
 J=[transpose(enei) real(S1) imag(S1) real(S2) imag(S2) real(S3) imag(S3) real(S4) imag(S4)];
  filename='jones.xlsx';
  xlswrite(filename,J);

  %write the intensities
 I=[transpose(enei) inten1 inten2];
  filename='intensity.xlsx';
  xlswrite(filename,I);



